require 'yaml'
require 'fileutils'
require_relative 'version'

require_relative 'upman/utils/symbolize_helper'
require_relative 'upman/utils/helper'
require_relative 'upman/utils/api'
require_relative 'upman/utils/files'
require_relative 'upman/utils/dynload'
require_relative 'upman/utils/parser'

require_relative 'upman/core/register'
require_relative 'upman/core/daemon'
require_relative 'upman/core/config'
require_relative 'upman/core/extension_base'
require_relative 'upman/core/worker'

require_relative 'upman/services/node'
require_relative 'upman/services/install_history'
require_relative 'upman/services/installed_packages'

require_relative 'upman/server/socket'
require_relative 'upman/server/base_servlet'

require_relative 'upman/worker/base_worker'

module Upman
  def self.run!(options)
    config_file = nil
    config_file = "config.yml" if File.exist? "config.yml"
    config_file = "/etc/upman/config.yml" if File.exist? "/etc/upman/config.yml"

    if config_file.nil?
      p "Can not find configuration file in /etc/upman/config.yml"
      return nil
    end

    Core::Config.load!(config_file)
    Core::Daemon.new(options).run!
  end
end