module Upman
  module Extensions
    class GetInstalledPackages < ::Upman::Core::ExtensionBase
      REQUEST_PATH = "getInstalledPackages"

      def register
        return Servlet
      end

      class Servlet < ::Upman::Server::BaseServlet

        attr_accessor :requested

        # rubocop:disable Naming/MethodName
        def do_GET(request, response)
          # rubocop:enable Naming/MethodName

          super(request, response)

          unless is_authenticated(request)
            response = not_authorized(response, "Request declined")
            return response
          end

          @requested = get_param('requested', 'int')

          if (body = perform_action)
            response = ok(response, body)
          end
        end

        def perform_action
          installed_package_service = Upman::Service::InstalledPackages.new
          installed_package_service.get(@requested).to_json
        end

      end
    end
  end
end