module Upman
  module Extensions
    class Index < ::Upman::Core::ExtensionBase
      REQUEST_PATH = "index"

      def register
        return Servlet
      end

      class Servlet < ::Upman::Server::BaseServlet

        include ::Upman::Utils::Dynload

        # rubocop:disable Naming/MethodName
        def do_GET(request, response)
          # rubocop:enable Naming/MethodName

          super(request, response)
          response = ok(response, perform_action(request))
        end

        def perform_action(request)
          endpoints = []
          hostname = request.request_uri.to_s.sub(request.script_name, '')
          ::Upman::Core::Config.daemon[:extensions].each do |extension|
            ext_obj = dynload("Upman::Extensions::#{extension.split('_').map(&:capitalize).join('')}")
            endpoints.append "#{hostname}/#{ext_obj ::REQUEST_PATH}.do"
          end
          "{\"message\": \"upman-#{::Upman::Version::VERSION} - Daemon is running\", \"endpoints\": #{endpoints.to_json}}"
        end

      end

    end
  end
end