module Upman
  module Extensions
    class InstallPackage < ::Upman::Core::ExtensionBase

      REQUEST_PATH = "installPackage"

      def register
        return Servlet
      end

      # Servlet action for WEBrick
      class Servlet < ::Upman::Server::BaseServlet

        attr_accessor :payload

        # rubocop:disable Naming/MethodName
        def do_GET(request, response)
          # rubocop:enable Naming/MethodName

          super(request, response)

          unless is_authenticated(request)
            response = not_authorized(response, "Request declined")
            return response
          end

          @payload = get_param('payload', 'json', false)

          if (body = perform_action)
            response = ok(response, body)
          end
        end

        def perform_action
          "{\"autentication\": \"failed - no valid certifacte was given\"}"
        end

      end

    end
  end
end