module Upman
  module Extensions
    class Ping < ::Upman::Core::ExtensionBase
     REQUEST_PATH = "ping"

     def register
       return Servlet
     end

     class Servlet < ::Upman::Server::BaseServlet

       # rubocop:disable Naming/MethodName
       def do_GET(request, response)
         # rubocop:enable Naming/MethodName

         super(request, response)

         unless is_authenticated(request)
           response = not_authorized(response, "Request declined")
           return response
         end

         response = ok(response, perform_action)
       end

       def perform_action
          "{\"pong\": true, \"message\": \"upman-#{::Upman::Version::VERSION} - Daemon is running\"}"
        end
      end

    end
  end
end