module Upman
  module Service
    class InstalledPackages

      include ::Upman::Utils::Parser

      def get(auto_installed)
        result = []
        extended_states = File.open('/var/lib/apt/extended_states', 'rb', &:read)
        extended_states.split("\n\n").each do |chunk|
          installed_packages = _get_hashed_values(chunk)
          if auto_installed.empty?
            result.append installed_packages
          else
            if installed_packages['auto_installed'] == auto_installed
              result.append installed_packages
            end
          end
        end
        result
      end
    end
  end
end