module Upman
  module Service
    class Node

      require 'securerandom'
      require 'facter'
      using SymbolizeHelper

      attr_accessor :node_config

      def initialize
        @node_config = 'node.yml'
      end


      def get_node_uuuid
        data = YAML::load_file(@node_config).deep_symbolize_keys
        data[:uuid]
      end

      def generate_node_data
        unless File.exist? @node_config
          data = {
              hostname: Socket.gethostbyname(Socket.gethostname).first,
              uuid: SecureRandom.uuid,
          }
          File.write(@node_config, data.to_yaml)
        end
        update_node_data
      end

      def update_node_data
        unless File.exist? @node_config
          generate_node_data
        end

        data = YAML::load_file(@node_config).deep_symbolize_keys
        data.merge!(
            operatingsystem: Facter['operatingsystem'].value,
            rubyversion: Facter['rubyversion'].value,
            operatingsystemrelease: Facter['operatingsystemrelease'].value,
            last_sync: DateTime.now
        )
        File.write(@node_config, data.to_yaml)
        data
      end
    end
  end
end